<template>
  <div class="user">
    <byTable
      :source="sourceList.data"
      :pagination="sourceList.pagination"
      :config="config"
      :loading="loading"
      highlight-current-row
      :selectConfig="selectConfig"
      :action-list="[
        {
          text: '添加字典',
          action: () => openModal('add'),
        },
      ]"
      @get-list="getList">
      <template #slotName="{ item }">
        {{ item.createTime }}
      </template>
    </byTable>

    <el-dialog :title="modalType == 'add' ? '新增' : '编辑'" v-if="dialogVisible" v-model="dialogVisible" width="500" v-loading="loading">
      <byForm :formConfig="formConfig" :formOption="formOption" v-model="formData.data" :rules="rules" ref="byform"> </byForm>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button type="primary" @click="submitForm('byform')" size="large" :loading="submitLoading">确 定</el-button>
      </template>
    </el-dialog>

    <el-dialog title="字典维护" v-if="dictCommonModal" v-model="dictCommonModal" width="1000" class="dictCommonModal" v-loading="loading">
      <dictTenantDtl :data="formData"></dictTenantDtl>
      <template #footer>
        <el-button @click="dictCommonModal = false" size="large">关闭</el-button>
      </template>
    </el-dialog>
  </div>
</template>

<script setup>
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import dictTenantDtl from "./dictTenantDtl.vue";
import { computed, ref } from "vue";
import useUserStore from "@/store/modules/user";

const dictCommonModal = ref(false);
const loading = ref(false);
const submitLoading = ref(false);
const sourceList = ref({
  data: [],
  pagination: {
    total: 0,
    pageNum: 1,
    pageSize: 10,
    tenantId: useUserStore().user.tenantId,
  },
});
let dialogVisible = ref(false);
let modalType = ref("add");
let rules = ref({
  code: [{ required: true, message: "请输入字典编码", trigger: "blur" }],
  name: [{ required: true, message: "请输入字典名称", trigger: "blur" }],
  status: [{ required: true, message: "请选择字典状态", trigger: "blur" }],
});
const { proxy } = getCurrentInstance();
const selectConfig = computed(() => {
  return [
    {
      label: "字典来源",
      prop: "type",
      data: [
        {
          label: "业务字典",
          value: "1",
        },
        {
          label: "自定义字典",
          value: "2",
        },
      ],
    },
    {
      label: "状态",
      prop: "status",
      data: [
        {
          label: "禁用",
          value: "0",
        },
        {
          label: "启用",
          value: "1",
        },
      ],
    },
  ];
});
const config = computed(() => {
  return [
    {
      attrs: {
        label: "字典类型",
        prop: "type",
      },
      render(type) {
        //1审核中 2审核通过 3审核不通过
        return type == 2 ? "自定义字典" : "业务字典";
      },
    },
    {
      attrs: {
        label: "字典编码",
      },
      renderHTML(row) {
        return [
          {
            attrs: {
              label: row.code,
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              openDtlModal(row);
            },
          },
        ];
      },
    },
    {
      attrs: {
        label: "字典名称",
        prop: "name",
      },
    },

    {
      attrs: {
        label: "状态",
        width: 100,
        prop: "status",
      },
      render(status) {
        //1审核中 2审核通过 3审核不通过
        return status == 0 ? "禁用" : "启用";
      },
    },
    {
      attrs: {
        label: "备注",
        prop: "remark",
      },
    },

    {
      attrs: {
        label: "操作",
        width: "200",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        if (row.type == 2) {
          return [
            {
              attrs: {
                label: "修改",
                type: "primary",
                text: true,
              },
              el: "button",
              click() {
                getDtl(row);
              },
            },
            {
              attrs: {
                label: "删除",
                type: "primary",
                text: true,
              },
              el: "button",
              click() {
                // 弹窗提示是否删除
                ElMessageBox.confirm("此操作将删除该数据, 是否继续?", "提示", {
                  confirmButtonText: "确定",
                  cancelButtonText: "取消",
                  type: "warning",
                }).then(() => {
                  // 删除
                  proxy
                    .post("/dictTenantType/delete", {
                      id: row.id,
                    })
                    .then((res) => {
                      ElMessage({
                        message: "删除成功",
                        type: "success",
                      });
                      getList();
                    });
                });
              },
            },
          ];
        }
      },
    },
  ];
});
const formData = reactive({
  data: {},
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const formConfig = computed(() => {
  return [
    {
      type: "input",
      prop: "code",
      label: "字典编码",
      required: true,
      disabled: formData.data.id,
      maxlength:"50"
    },
    {
      type: "input",
      prop: "name",
      label: "字典名称",
      maxlength:"50"
    },
    {
      label: "启用状态",
      prop: "status",
      type: "select",
      data: [
        {
          label: "禁用",
          value: 0,
        },
        {
          label: "启用",
          value: 1,
        },
      ],
    },
    {
      type: "input",
      prop: "remark",
      label: "备注",
      border: true,
    },
  ];
});
const openDtlModal = (row) => {
  formData.data = { ...row, tenantId: useUserStore().user.tenantId };
  dictCommonModal.value = true;
};
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy.post("/dictTenantType/page", sourceList.value.pagination).then((message) => {
    sourceList.value.data = message.rows;
    sourceList.value.pagination.total = message.total;
    setTimeout(() => {
      loading.value = false;
    }, 200);
  });
};
const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formData.data = {
    userType: 1,
  };
};
const submitForm = () => {
  byform.value.handleSubmit(() => {
    proxy
      .post("/dictTenantType/" + (modalType.value == "add" ? "add" : "edit"), {
        ...formData.data,
        tenantId: useUserStore().user.tenantId,
      })
      .then((res) => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        getList();
      });
  });
};
const getDept = () => {
  proxy.get("/system/user/deptTree").then((res) => {
    formConfig.value[0].data = res.data;
  });
};
const getDtl = (row) => {
  modalType.value = "edit";
  dialogVisible.value = true;
  setTimeout(() => {
    formData.data = row;
    if (!formData.data.status) {
      formData.data.status = 0;
    }
  }, 200);
};
getDept();
getList();
</script>

<style lang="scss" scoped>
.dictCommonModal .el-dialog__body {
  background: #eee;
}
.user {
  padding: 20px;
}
</style>
